
<p align="center">
  <img src="https://user-images.githubusercontent.com/3836517/32965280-1a2b63ce-cbe7-11e7-8ee1-ba47313503c5.png" width="500px" alt="SQB Logo"/>
</p>

<br>
  
[![NPM Version][npm-image]][npm-url]
[![NPM Downloads][downloads-image]][downloads-url]
[![Build Status][travis-image]][travis-url]
[![Test Coverage][coveralls-image]][coveralls-url]

[![Dependencies][dependencies-image]][dependencies-url]
[![DevDependencies][devdependencies-image]][devdependencies-url]
[![Package Quality][quality-image]][quality-url]


## About SQB

SQB is an [extensible](./docs/extensions.md), multi-dialect SQL query builder and Database connection wrapper for NodeJS.

## Main goals

- Single code base for any sql based database
- Powerful and simplified query coding scheme
- Fast applications with low memory requirements
- Let applications work with large data tables efficiently
- Support latest JavaScript language standards
- Lightweight and [extensible](./docs/extensions.md) framework. 


You can report bugs and discuss features on the [GitHub issues](https://github.com/sqbjs/sqb/issues) page

Thanks to all of the great [contributions](https://github.com/sqbjs/sqb/graphs/contributors) to the project.

You may want to check detailed [DOCUMENTATION](https://sqbjs.github.io/sqb/)


## Installation

```bash
$ npm install sqb --save
```

## Node Compatibility

  - node >= 6.x
  
## Change log

To see changelog click [here](https://github.com/sqbjs/sqb/commits/master)

  
### License
SQB is available under [MIT](LICENSE) license.

[npm-image]: https://img.shields.io/npm/v/sqb.svg
[npm-url]: https://npmjs.org/package/sqb
[travis-image]: https://img.shields.io/travis/sqbjs/sqb/master.svg
[travis-url]: https://travis-ci.org/sqbjs/sqb
[coveralls-image]: https://img.shields.io/coveralls/sqbjs/sqb/master.svg
[coveralls-url]: https://coveralls.io/r/sqbjs/sqb
[downloads-image]: https://img.shields.io/npm/dm/sqb.svg
[downloads-url]: https://npmjs.org/package/sqb
[gitter-image]: https://badges.gitter.im/sqbjs/sqb.svg
[gitter-url]: https://gitter.im/sqbjs/sqb?utm_source=badge&utm_medium=badge&utm_campaign=pr-badge&utm_content=badge
[dependencies-image]: https://david-dm.org/sqbjs/sqb/status.svg
[dependencies-url]:https://david-dm.org/sqbjs/sqb
[devdependencies-image]: https://david-dm.org/sqbjs/sqb/dev-status.svg
[devdependencies-url]:https://david-dm.org/sqbjs/sqb?type=dev
[quality-image]: http://npm.packagequality.com/shield/sqb.png
[quality-url]: http://packagequality.com/#?package=sqb
